org.apache.fop.render.ps

## Class PSPainter

- java.lang.Object
- - org.apache.fop.render.intermediate.AbstractIFPainter<PSDocumentHandler>
  - - org.apache.fop.render.ps.PSPainter

- All Implemented Interfaces:
    IFPainter

      public class PSPainter
      extends AbstractIFPainter<PSDocumentHandler>

  IFPainter implementation that produces PostScript.

- - ### Field Summary

    - ### Fields inherited from class org.apache.fop.render.intermediate.AbstractIFPainter

      `INSTREAM_OBJECT_URI, state`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `PSPainter(PSDocumentHandler documentHandler)` Default constructor.
    `protected` | `PSPainter(PSDocumentHandler documentHandler, IFState state)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `beginTextObject()` Indicates the beginning of a text object.
    `void` | `clipBackground(Rectangle rect, BorderProps bpsBefore, BorderProps bpsAfter, BorderProps bpsStart, BorderProps bpsEnd)` Restricts the current clipping region to the inner border.
    `void` | `clipRect(Rectangle rect)` Restricts the current clipping region with the given rectangle.
    `protected Map` | `createDefaultImageProcessingHints(org.apache.xmlgraphics.image.loader.ImageSessionContext sessionContext)` Creates the default map of processing hints for the image loading framework.
    `protected RenderingContext` | `createRenderingContext()` Creates a new RenderingContext instance.
    `void` | `drawBorderRect(Rectangle rect, BorderProps top, BorderProps bottom, BorderProps left, BorderProps right, Color innerBackgroundColor)` Draws a border rectangle.
    `void` | `drawImage(Document doc, Rectangle rect)` Draws an image (represented by a DOM document) inside a given rectangle.
    `void` | `drawImage(String uri, Rectangle rect)` Draws an image identified by a URI inside a given rectangle.
    `protected void` | `drawImageUsingImageHandler(org.apache.xmlgraphics.image.loader.ImageInfo info, Rectangle rect)` Loads a preloaded image and draws it using a suitable image handler.
    `void` | `drawLine(Point start, Point end, int width, Color color, RuleStyle style)` Draws a line.
    `void` | `drawText(int x, int y, int letterSpacing, int wordSpacing, int[][] dp, String text)` Draws text.
    `void` | `endGroup()` Ends the current group and restores the previous coordinate system (and layer).
    `protected void` | `endTextObject()` Indicates the end of a text object.
    `void` | `endViewport()` Ends the current viewport and restores the previous coordinate system.
    `void` | `fillRect(Rectangle rect, Paint fill)` Fills a rectangular area.
    `protected void` | `restoreGraphicsState()` Restores the last graphics state of the rendering engine.
    `protected void` | `saveGraphicsState()` Saves the graphics state of the rendering engine.
    `void` | `startGroup(AffineTransform transform, String layer)` Starts a new group of graphical elements.
    `void` | `startViewport(AffineTransform transform, Dimension size, Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system.

    - ### Methods inherited from class org.apache.fop.render.intermediate.AbstractIFPainter

      `drawImage, drawImage, drawImageUsingDocument, drawImageUsingURI, drawSVGText, drawText, getContext, getDocumentHandler, getFontInfo, getFontKey, getImageInfo, getLineBoundingBox, getUserAgent, hasOnlySolidBorders, isBackgroundRequired, setFont, startGroup, startViewport, toPoints`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PSPainter

          public PSPainter(PSDocumentHandler documentHandler)

      Default constructor.
      Parameters:
        `documentHandler` - the parent document handler

    - #### PSPainter

          protected PSPainter(PSDocumentHandler documentHandler,
                              IFState state)

  - ### Method Detail

    - #### startViewport

          public void startViewport(AffineTransform transform,
                                    Dimension size,
                                    Rectangle clipRect)
                             throws IFException

      Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `size` - the size of the viewport
        `clipRect` - the clipping rectangle (may be null)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endViewport

          public void endViewport()
                           throws IFException

      Ends the current viewport and restores the previous coordinate system.
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startGroup

          public void startGroup(AffineTransform transform,
                                 String layer)
                          throws IFException

      Starts a new group of graphical elements. Corresponds to SVG's g element.
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `layer` - an optional layer label (or null if none)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endGroup

          public void endGroup()
                        throws IFException

      Ends the current group and restores the previous coordinate system (and layer).
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### createDefaultImageProcessingHints

          protected Map createDefaultImageProcessingHints(org.apache.xmlgraphics.image.loader.ImageSessionContext sessionContext)

      Creates the default map of processing hints for the image loading framework.
      Overrides:
        `createDefaultImageProcessingHints` in class `AbstractIFPainter<PSDocumentHandler>`
      Parameters:
        `sessionContext` - the session context for access to resolution information
      Returns:
        the default processing hints

    - #### createRenderingContext

          protected RenderingContext createRenderingContext()

      Creates a new RenderingContext instance.
      Specified by:
        `createRenderingContext` in class `AbstractIFPainter<PSDocumentHandler>`
      Returns:
        the new rendering context.

    - #### drawImageUsingImageHandler

          protected void drawImageUsingImageHandler(org.apache.xmlgraphics.image.loader.ImageInfo info,
                                                    Rectangle rect)
                                             throws org.apache.xmlgraphics.image.loader.ImageException,
                                                    IOException

      Loads a preloaded image and draws it using a suitable image handler.
      Overrides:
        `drawImageUsingImageHandler` in class `AbstractIFPainter<PSDocumentHandler>`
      Parameters:
        `info` - the information object of the preloaded image
        `rect` - the rectangle in which to paint the image
      Throws:
        `org.apache.xmlgraphics.image.loader.ImageException` - if there's an error while processing the image
        `IOException` - if there's an I/O error while loading the image

    - #### drawImage

          public void drawImage(String uri,
                                Rectangle rect)
                         throws IFException

      Draws an image identified by a URI inside a given rectangle. This is the equivalent to an fo:external-graphic in XSL-FO.
      Parameters:
        `uri` - the image's URI
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawImage

          public void drawImage(Document doc,
                                Rectangle rect)
                         throws IFException

      Draws an image (represented by a DOM document) inside a given rectangle. This is the equivalent to an fo:instream-foreign-object in XSL-FO.
      Parameters:
        `doc` - the DOM document containing the foreign object
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### clipRect

          public void clipRect(Rectangle rect)
                        throws IFException

      Restricts the current clipping region with the given rectangle.
      Parameters:
        `rect` - the rectangle's coordinates and extent
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### clipBackground

          public void clipBackground(Rectangle rect,
                                     BorderProps bpsBefore,
                                     BorderProps bpsAfter,
                                     BorderProps bpsStart,
                                     BorderProps bpsEnd)
                              throws IFException

      Restricts the current clipping region to the inner border.
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `bpsBefore` - the border segment on the before-side (top)
        `bpsAfter` - the border segment on the after-side (bottom)
        `bpsStart` - the border segment on the start-side (left)
        `bpsEnd` - the border segment on the end-side (right)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### fillRect

          public void fillRect(Rectangle rect,
                               Paint fill)
                        throws IFException

      Fills a rectangular area.
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `fill` - the fill paint
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawBorderRect

          public void drawBorderRect(Rectangle rect,
                                     BorderProps top,
                                     BorderProps bottom,
                                     BorderProps left,
                                     BorderProps right,
                                     Color innerBackgroundColor)
                              throws IFException

      Draws a border rectangle. The border segments are specified through `BorderProps` instances.
      Specified by:
        `drawBorderRect` in interface `IFPainter`
      Overrides:
        `drawBorderRect` in class `AbstractIFPainter<PSDocumentHandler>`
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `top` - the border segment on the top edge
        `bottom` - the border segment on the bottom edge
        `left` - the border segment on the left edge
        `right` - the border segment on the right edge
        `innerBackgroundColor` - the color of the inner background
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawLine

          public void drawLine(Point start,
                               Point end,
                               int width,
                               Color color,
                               RuleStyle style)
                        throws IFException

      Draws a line. NOTE: Currently, only horizontal lines are implemented!
      Specified by:
        `drawLine` in interface `IFPainter`
      Overrides:
        `drawLine` in class `AbstractIFPainter<PSDocumentHandler>`
      Parameters:
        `start` - the start point of the line
        `end` - the end point of the line
        `width` - the line width
        `color` - the line color
        `style` - the line style (using the Constants.EN_* constants for the rule-style property)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### saveGraphicsState

          protected void saveGraphicsState()
                                    throws IOException

      Saves the graphics state of the rendering engine.
      Throws:
        `IOException` - if an I/O error occurs

    - #### restoreGraphicsState

          protected void restoreGraphicsState()
                                       throws IOException

      Restores the last graphics state of the rendering engine.
      Throws:
        `IOException` - if an I/O error occurs

    - #### beginTextObject

          protected void beginTextObject()
                                  throws IOException

      Indicates the beginning of a text object.
      Throws:
        `IOException` - if an I/O error occurs

    - #### endTextObject

          protected void endTextObject()
                                throws IOException

      Indicates the end of a text object.
      Throws:
        `IOException` - if an I/O error occurs

    - #### drawText

          public void drawText(int x,
                               int y,
                               int letterSpacing,
                               int wordSpacing,
                               int[][] dp,
                               String text)
                        throws IFException

      Draws text. The initial coordinates (x and y) point to the starting point at the normal baseline of the font. The parameters letterSpacing, wordSpacing and the array dx are optional and can be used to influence character positioning (for example, for kerning).
      Parameters:
        `x` - X-coordinate of the starting point of the text
        `y` - Y-coordinate of the starting point of the text
        `letterSpacing` - additional spacing between characters (may be 0)
        `wordSpacing` - additional spacing between words (may be 0)
        `dp` - an array of 4-tuples, expressing [X,Y] placment adjustments and [X,Y] advancement adjustments, in that order (may be null); if not null, then adjustments.length must be the same as text.length()
        `text` - the text
      Throws:
        `IFException` - if an error occurs while handling this event

Copyright © 2023 Apache Software Foundation. All rights reserved.